#ifndef GUARD_imagebutton_h
#define GUARD_imagebutton_h
// Sagua is music player.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <string>

#include <gtkmm/box.h>
#include <gtkmm/eventbox.h>
#include <gtkmm/image.h>

// class for rollover image button
// 
// If mouse is in the button area, display overImage.
// If user click the button, display pressImage.
// Or display normalImage.
class ImageButton : public Gtk::EventBox
{
    public:
	ImageButton(const std::string&, const std::string&, const std::string&);
	virtual ~ImageButton();

	sigc::signal<void> SignalPress();

    private:
	Gtk::VBox mainBox_;
	Gtk::Image normalImage_;
	Gtk::Image overImage_;
	Gtk::Image pressImage_;

	Gtk::Image* prevImage_;

	sigc::signal<void> signalPress_;

	bool OnBtnPress(GdkEventButton*);
	bool OnBtnRelease(GdkEventButton*);
	bool OnEnterNotify(GdkEventCrossing*);
	bool OnLeaveNotify(GdkEventCrossing*);
	

};

#endif
