#ifndef GUARD_player_ogg_h
#define GUARD_player_ogg_h
// Sagua is music player.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <vorbis/vorbisfile.h>

#include <glibmm.h>

#include "player.h"

class MainManager;

namespace VORBIS {

    enum DecodeState {
	UNKNOWN = 0,
	PLAY = -1,
	STOP = -2 
    };

    class OGGPlayer : public Player
    {
	public:
	    OGGPlayer(MainManager&);
	    virtual ~OGGPlayer();

	    virtual bool Init(const std::string&);
	    virtual void Start();
	    virtual void Stop();
	    virtual void Seek(const unsigned long&);
	    virtual long int CurrentTime();
	    
	private:
	    OGGPlayer& operator=(const OGGPlayer&);
	    OGGPlayer(const OGGPlayer&);
	    
	    float **buf_;

	    Glib::Dispatcher signalFinish_;
	    Glib::Dispatcher signalTimerUpdate_;

	    Glib::Mutex vfMutex_;
	    
	    OggVorbis_File vorbisFile_; 
	    
	    DecodeState decodeState_;

	    long int currentSeconds_;
	    const int buflen_;
	    int sampleRate_;
	    int ret_;
	    int bs_;

	    bool ovOpenSuccess_;
	    
	    MainManager& mainManager_;
	    
	    FILE* inFile_;
	    
	    virtual void Clean();
	    virtual void Reset();    
    };

}

#endif
