// Sagua is music player.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <ctime>

#include <unistd.h>

#include <gtkmm/main.h>
#include <libintl.h>
#include "../include/mainmanager.h"
#include "../include/trace.h"

int main(int argc, char* argv[])
{
    char opt;
    
    while((opt = getopt(argc, argv, "dh")) != -1) {
	switch(opt) {
	    case 'd':
		Tracer::activeTrace() = true;
		break;
	    case 'h':
	    default:
		std::cout << "Usage : " << argv[0] << " [-options]" << std::endl << std::endl;
		std::cout << "Options : " << std::endl;
		std::cout << "  -d\tDisplay debug message(need build with debugtrace)." << std::endl;
		std::cout << "  -h\tDisplay this help message." << std::endl;	
		exit(0);
	}
    }
    
    Tracer::Trace trace("main");
    
    srand( static_cast<unsigned>( time(NULL) ) );
    
    if(!Glib::thread_supported()) {
    	trace.Debug("thread init");

	Glib::thread_init();
    }

    Gtk::Main kit(argc, argv);

    bindtextdomain(GETTEXT_PACKAGE, LOCALEDIR);
    bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
    textdomain(GETTEXT_PACKAGE);

    MainManager* mainManager = MainManager::Create();
    if(mainManager != NULL)
	mainManager->Run();

    return 0;	
}
