// Sagua is music player.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "../include/mainmanager.h"
#include "../include/aboutdlg.h"

MainManager::MainManager()
    : audioFormatLittleEndian_(AO_FMT_LITTLE),
    audioFormatBigEndian_(AO_FMT_BIG),
    audioFormatNativeEndian_(AO_FMT_NATIVE),
    trayIcon_(*this),
    mainWnd_(*this)
{
    audio_ = Audio::Create(*this);

    trayIconFirstBtnCallbacks_["prev"] = &MainManager::PlayCtrlPrev;
    trayIconFirstBtnCallbacks_["play"] = &MainManager::PlayCtrlPlay;
    trayIconFirstBtnCallbacks_["stop"] = &MainManager::PlayCtrlStop;
    trayIconFirstBtnCallbacks_["next"] = &MainManager::PlayCtrlNext;
    trayIconFirstBtnCallbacks_["fileinfo"] = &MainManager::FileInfo;

    mainWnd_.show();

    if(!preference_.SuccessLoadConfig())
	mainWnd_.OnMenuPreference();
}

MainManager::~MainManager()
{

}

void MainManager::MainWndIconifyEvent()
{
    mainWnd_.hide();
    mainWnd_.SetSkipTimeUpdate(true);
    trayIcon_.ToggleMainWndOpenMenuSensitivity(true);
}

void MainManager::MainWndDeiconify()
{
    trayIcon_.ToggleMainWndOpenMenuSensitivity(false);
    mainWnd_.SetSkipTimeUpdate(false);
    mainWnd_.TimeUpdate();
    mainWnd_.show();
}

void MainManager::About()
{
    AboutDlg aboutDlg;

    aboutDlg.run();
}

void MainManager::Quit()
{
    mainWnd_.SaveState();
    mainWnd_.hide();

    Gtk::Main::quit();
}
